// -------------------------
// Parachute events

// By Axolotl
// BL_ID 32440

// This will ONLY work with Aloshi's Parachute
// -------------------------


// Part 1: Force-enable parachute
// This part is automatically done on server.cs


// ----------
// Part 2: Output events
// Don't get your events mixed up.

registerOutputEvent( Player , startParachute );
registerOutputEvent( Player , stopParachute );


// ----------
// Part 3: Anti-Break / isParaing variable

// A variable is set to NULL when it is created.
// We want this to not break VCE, so we set it to 0

package ParaEvents_AntiBreak
{    	
	function GameConnection::onClientEnterGame( %client )
	{
		parent::onClientEnterGame( %client );
		%client.player.schedule( 500 , resetParaVar ); // We don't want to deadlock
	}
};


function resetParaVar( %player ){ %player.paraing = 0; } // I don't think you can set a variable directly in a schedule

// %player.paraing is a variable but it's poorly done


function player::startParachute( %player )
{
	if( !%player.paraing )
	{
		ParaImage::onFire( NULL , %player , NULL ); //Despite using NULL, this does NOT give a warning.
	}
}
function player::stopParachute( %player )
{
	if( %player.paraing )
	{
		ParaImage::onFire( NULL , %player , NULL );
		ParaImage::onUnMount( NULL , %player );
	}
}


// ----------
// Part 4: VCE interaction

package ParaEvents_InitVars
{
	function VCE_initServer()
	{
		Parent::VCE_initServer();
		registerSpecialVar(Player,"isParaing","%this.paraing");
	}
};


// ----------
// Part 5: Activate packages

activatePackage(ParaEvents_AntiBreak);
activatePackage(ParaEvents_InitVars);


